#version 400 compatibility
#define WANGHASH
//#version 120
//#define OLD_FRAG

#include "MathUtils.frag"
#include "newIQPath.frag"
//#include "iqPath_Light.frag"
//#include "Sky-PathTracer.frag"


#group Menger
uniform int Iterations;  slider[0,8,100]
uniform float Scale; slider[0.00,3.0,4.00]
uniform vec3 Offset; slider[(0,0,0),(1,1,1),(3,3,3)]
uniform bool Use_Floor; checkbox[false]
uniform int ColorIterations;  slider[0,2,100]

float DE(vec3 z)
{
	float p = z.z;
	float r;
	int n = 0;
	z = abs(z);
	if (z.x<z.y){ z.xy = z.yx;}
	if (z.x<z.z){ z.xz = z.zx;}
	if (z.y<z.z){ z.yz = z.zy;}
	if (z.z<1./3.){ z.z -=2.*( z.z-1./3.);}
	while (n < Iterations && dot(z,z)<100.0) {
		z=Scale* (z-Offset)+Offset;
		z = abs(z);
		if (z.x<z.y){ z.xy = z.yx;}
		if (z.x< z.z){ z.xz = z.zx;}
		if (z.y<z.z){ z.yz = z.zy;}
		if (z.z<1./3.*Offset.z){ z.z -=2.*( z.z-1./3.*Offset.z);}
		r = dot(z-Offset, z-Offset);
if (n<ColorIterations) orbitTrap = min(orbitTrap, abs(vec4(z.xyz,dot(z,z))));
		n++;
	}
	//return (length(z)-sqrt(3.) ) * pow(Scale, float(-n));
	return(Use_Floor)? min(p,float(z.x-Offset) * pow(Scale, float(-n))):float(z.x-Offset) * pow(Scale, float(-n));
}

#preset Default
FOV = 0.4
Eye = -1.31956,-3.01129,0.679557
Target = 3.39976,5.79795,0.325427
Up = 0.0302238,0.0239985,0.999255
EquiRectangular = false
FocalPlane = 2.0652
Aperture = 0
ApertureNbrSides = 4
ApertureRot = 0
ApStarShaped = false
BokehCircle = 1.7
Gamma = 2
ToneMapping = 2
Exposure = 1
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
RayBounces = 2 Locked
RaySteps = 312 Locked
FudgeFactor = 1
HitDistance = 3e-05
MaxDepth = 30 Locked
Mat_Color = 0.27451,0.27451,0.27451
Mat_Refl = 1e-06
Mat_ReflExp = 0.89024
UseTexture = false
DeTexScale = 0.2439
DeTexExposure = 0.14706
OrbitStrength = 0
X = 1,0.584314,0,-0.56862 Locked
Y = 0.113725,0,1,1 Locked
Z = 1,0.584314,0,0.09804 Locked
R = 1,1,1,-0.0099 Locked
CycleColors = false Locked
Cycles = 3.47327 Locked
SpotLight = 1,0.8,0.5,4
SpotLightDir = 0.35802,0.62962
SpotSize = 0
SpotExp = 0.5
BgColor = 0.231373,0.329412,0.458824,3.1429
Ambience = 1
GRIter = 11
GRPower = 0.30303
Iterations = 3
Scale = 2.57628
Offset = 1.33929,1.6875,0
Use_Floor = true
ColorIterations = 3
Fog = 0
#endpreset




#preset Fog
FOV = 0.4
Eye = -1.14773,0.809729,0.638083
Target = 6.60592,-4.47842,-2.81392
Up = 0.272192,-0.213392,0.938273
EquiRectangular = false
FocalPlane = 1
Aperture = 0
ApertureNbrSides = 4
ApertureRot = 0
ApStarShaped = false
BokehCircle = 1.7
Gamma = 1.7
ToneMapping = 5
Exposure = 1
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
RayBounces = 5 Locked
RaySteps = 454 Locked
FudgeFactor = 1
HitDistance = 0.00017
MaxDepth = 22.8422 Locked
Mat_Color = 0.741176,0.741176,0.741176
Mat_Refl = 1e-05
Mat_ReflExp = 0.89024
UseTexture = false
DeTexScale = 0.2439
DeTexExposure = 0.14706
OrbitStrength = 0
X = 1,0.584314,0,-0.56862 Locked
Y = 0.113725,0,1,1 Locked
Z = 1,0.584314,0,0.09804 Locked
R = 1,1,1,-0.0099 Locked
CycleColors = false Locked
Cycles = 3.47327 Locked
SpotLight = 1,0.705882,0.368627,1.2
SpotLightDir = -0.11112,0.75308
SpotSize = 0
SpotExp = 0.5
BgColor = 0.231373,0.329412,0.458824,3.1429
Ambience = 1
GRIter = 0
GRPower = 0.31292
Iterations = 5
Scale = 2.1356
Offset = 0.80358,0.1875,1.74108
Use_Floor = true
ColorIterations = 3
Fog = 0.66
#endpreset



#preset GR1
FOV = 0.4
Eye = -2.41436,1.22875,0.307129
Target = 6.6094,-3.04702,0.845233
Up = -0.0694571,-0.0212727,0.995731
EquiRectangular = false
FocalPlane = 1
Aperture = 0
ApertureNbrSides = 4
ApertureRot = 0
ApStarShaped = false
BokehCircle = 1.7
Gamma = 1.9
ToneMapping = 5
Exposure = 1.2
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
RayBounces = 5 Locked
RaySteps = 454 Locked
FudgeFactor = 1
HitDistance = 0.00017
MaxDepth = 17.9886 Locked
Mat_Color = 0.27451,0.27451,0.27451
Mat_Refl = 1e-05
Mat_ReflExp = 0.89024
UseTexture = false
DeTexScale = 0.2439
DeTexExposure = 0.14706
OrbitStrength = 0
X = 1,0.584314,0,-0.56862 Locked
Y = 0.113725,0,1,1 Locked
Z = 1,0.584314,0,0.09804 Locked
R = 1,1,1,-0.0099 Locked
CycleColors = false Locked
Cycles = 3.47327 Locked
SpotLight = 1,0.862745,0.690196,1.001
SpotLightDir = 0.28396,-0.08642
SpotSize = 0
SpotExp = 0.5
BgColor = 0.231373,0.329412,0.458824,3.1429
Ambience = 3
GRIter = 6
GRPower = 0.55556
Iterations = 7
Scale = 2.30508
Offset = 1.58037,0.30087,1.6875
Use_Floor = true
ColorIterations = 3
Fog = 0.396
#endpreset


#preset GRTest
FOV = 0.21138
Eye = 0.315282,-1.37126,0.0932353
Target = -4.95272,7.05106,1.23886
Up = 0.0443842,-0.107341,0.993231
EquiRectangular = false
FocalPlane = 2.0652
Aperture = 0
ApertureNbrSides = 4
ApertureRot = 0
ApStarShaped = false
BokehCircle = 1.7
Gamma = 1.62035
ToneMapping = 5
Exposure = 1.2
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
RayBounces = 4 Locked
RaySteps = 312 Locked
FudgeFactor = 1
HitDistance = 0.00099
MaxDepth = 5 Locked
Mat_Color = 0.192157,0.439216,0.176471
Mat_Refl = 1
Mat_ReflExp = 0.79268
UseTexture = false
DeTexScale = 0.2439
DeTexExposure = 0.14706
OrbitStrength = 0
X = 1,0.584314,0,-0.56862 Locked
Y = 0.113725,0,1,1 Locked
Z = 1,0.584314,0,0.09804 Locked
R = 1,1,1,-0.0099 Locked
CycleColors = false Locked
Cycles = 3.47327 Locked
SpotLight = 1,0.8,0.5,10
SpotLightDir = 0.24396,-0.06172
SpotSize = 0
SpotExp = 0.5
BgColor = 0.231373,0.329412,0.458824,3.1429
Ambience = 1
GRIter = 9
GRPower = 0.61616
Iterations = 4
Scale = 2.88136
Offset = 1.47321,1.58037,1.04463
Use_Floor = true
ColorIterations = 3
Fog = 0.396
#endpreset



#preset test
FOV = 0.4
Eye = 0.454236,-3.40973,0.531785
Target = -0.3711,6.54609,0.979313
Up = 0.0368623,-0.0418302,0.998444
EquiRectangular = false
FocalPlane = 1.6848
Aperture = 0.048
ApertureNbrSides = 7
ApertureRot = 0
ApStarShaped = false
BokehCircle = 1.7
Gamma = 1.2037
ToneMapping = 5
Exposure = 1
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
RayBounces = 4 Locked
RaySteps = 312 Locked
FudgeFactor = 1
HitDistance = 1e-05
MaxDepth = 76.2319 Locked
Mat_Color = 0.129412,0.129412,0.129412 Locked
Mat_Refl = 1e-05 Locked
Mat_ReflExp = 0.075 Locked
UseTexture = false Locked
DeTexScale = 0.2439 Locked
DeTexExposure = 0.14706 Locked
OrbitStrength = 0
X = 1,0.584314,0,-0.56862 Locked
Y = 0.113725,0,1,1 Locked
Z = 1,0.584314,0,0.09804 Locked
R = 1,1,1,-0.0099 Locked
CycleColors = false Locked
Cycles = 3.47327 Locked
SpotLight = 1,0.913725,0.815686,7
SpotLightDir = 0.30864,0.875
SpotSize = 3.8542
SpotExp = 0.8249
BgColor = 0.184314,0.317647,0.462745,0.8571
Ambience = 2.52575
GRIter = 6 Locked
GRPower = 0.23232 Locked
Iterations = 4
Scale = 0.57628
Offset = 1.71429,1.84821,1.88508
Use_Floor = true
ColorIterations = 3
Fog = 0.3361
#endpreset





#preset test2
FOV = 0.30894
Eye = 0.664395,-1.85262,0.176193
Target = -5.86218,5.72366,0.235626
Up = -0.00763554,-0.0144212,0.999866
EquiRectangular = false
FocalPlane = 1.0265
Aperture = 0.008
ApertureNbrSides = 7
ApertureRot = 0
ApStarShaped = false
BokehCircle = 1.7
Gamma = 1.62035
ToneMapping = 5
Exposure = 1.2
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
RayBounces = 5 Locked
RaySteps = 312 Locked
FudgeFactor = 1
HitDistance = 0.00099
MaxDepth = 5 Locked
Mat_Color = 0.6,0.6,0.6 Locked
Mat_Refl = 1e-05 Locked
Mat_ReflExp = 0.075 Locked
UseTexture = false Locked
DeTexScale = 0.2439 Locked
DeTexExposure = 0.14706 Locked
OrbitStrength = 0
X = 1,0.584314,0,-0.56862 Locked
Y = 0.113725,0,1,1 Locked
Z = 1,0.584314,0,0.09804 Locked
R = 1,1,1,-0.0099 Locked
CycleColors = false Locked
Cycles = 3.47327 Locked
SpotLight = 1,0.686275,0.458824,10
SpotLightDir = -0.25372,-1
SpotSize = 3.8542
SpotExp = 0.8249
BgColor = 0.176471,0.32549,0.458824,2
Ambience = 2.2165
GRIter = 6 Locked
GRPower = 0.61616 Locked
Iterations = 6
Scale = 2.74576
Offset = 1.3125,1.47321,0.91071
Use_Floor = true
ColorIterations = 3
Fog = 0.4661
#endpreset

